import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class world here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class world extends World
{
    int x = 0;
    int y = 0;
    GreenfootImage background;
    boolean animated = false;
    int rep = 1;
    int level = 0;
    int score = 0;
    /**
     * Constructor for objects of class world.
     * 
     */
    public world(int i)
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1,false); 
        if(i>0){
            Greenfoot.setSpeed(50);
            level = i;
            background = new GreenfootImage("level"+level+".png");
            background.scale(1200,800);
            getBackground().drawImage(background,x,y);
            addObject(new Grid(),300,200);
            
            if(level <3)addObject(new Banana(),500,420);
            else if(level == 3) addObject(new Banana(),700,580);
            else addObject(new Banana(),300,700);
            animated = false;
        }
        else
        {
            Greenfoot.setSpeed(40);
            animated = true;
        }
    }
    public world(int i, int score2)
    {
        super(600, 400, 1,false); 
        if(i>0){
            Greenfoot.setSpeed(50);
            level = i;
            background = new GreenfootImage("level"+level+".png");
            background.scale(1200,800);
            getBackground().drawImage(background,x,y);
            addObject(new Grid(),300,200);
            if(level <3)addObject(new Banana(),500,420);
            else if(level == 3) addObject(new Banana(),700,580);
            else addObject(new Banana(),300,700);
            animated = false;
        }
        else
        {
            Greenfoot.setSpeed(40);
            animated = true;
        }
        this.score = score2;
    }
    public void animate()
    {
        if(rep<340)
        {
            GreenfootImage green;
            if(rep<10)
                green = new GreenfootImage("000"+rep+".png");
            else if(rep<100)
                green = new GreenfootImage("00"+rep+".png");
            else green = new GreenfootImage("0"+rep+".png");
            green.scale(600,400);
            setBackground(green);
            rep++;
        }
        else
        {
            Greenfoot.setSpeed(50);
            level = 1;
            background = new GreenfootImage("level"+1+".png");
            background.scale(1200,800);
            getBackground().drawImage(background,x,y);
            addObject(new Grid(),300,200);
            addObject(new Banana(),500,440);
            animated = false;
        }
    }
    public void act()
    {
        if(animated)
            animate();
        else
        {boolean moved = true;
        if(getObjects(Cart.class).size()>0)
        {
            Cart cart = (Cart)getObjects(Cart.class).get(0);
            x -= cart.getX()-300;
            y -= cart.getY()-200;
            Banana banana = (Banana)getObjects(Banana.class).get(0);
            banana.setLocation(banana.getX()-(cart.getX()-300),banana.getY()-(cart.getY()-200));
            cart.setLocation(300,200);
        }
        else if(Greenfoot.isKeyDown("up")&&y<0)
        {
            y++;
            Banana banana = (Banana)getObjects(Banana.class).get(0);
            banana.setLocation(banana.getX(),banana.getY()+1);
        }
        else if(Greenfoot.isKeyDown("down")&&y>-200){
            y--;
            Banana banana = (Banana)getObjects(Banana.class).get(0);
            banana.setLocation(banana.getX(),banana.getY()-1);
        }
        else if(Greenfoot.isKeyDown("right")&&x>-300){
            x--;
            Banana banana = (Banana)getObjects(Banana.class).get(0);
            banana.setLocation(banana.getX()-1,banana.getY());
        }
        else if(Greenfoot.isKeyDown("left")&&x<0)
        {
            x++;
            Banana banana = (Banana)getObjects(Banana.class).get(0);
            banana.setLocation(banana.getX()+1,banana.getY());
        }
        if(moved){ 
            getBackground().drawImage(background,x,y);
            getBackground().drawString("Score: "+score,100,100);
        }
        if(Greenfoot.mouseClicked(this)) set(0);
    }
    }
    public void set(int i)
    {
        if(i>0)
            score += 1000;
        if(i+level<5) Greenfoot.setWorld(new world(level+i,score));
        else{ 
            getBackground().setColor(Color.red);
            UserInfo me = UserInfo.getMyInfo();
            if (me != null)
            {
                if (score > me.getScore())
                {
                    // It's a high-score, only update the score if ours is now higher:
                    me.setScore(score);
                    me.store();
                }
            }
            Greenfoot.setWorld(new ScoreWorld(600, 400));
            Greenfoot.stop();
        }
    }
}
